package io.lumine.cosmetics.menus;

import io.lumine.cosmetics.MCCosmeticsPlugin;
import io.lumine.cosmetics.api.cosmetics.EquippedCosmetic;
import io.lumine.cosmetics.commands.CommandHelper;
import io.lumine.mythic.bukkit.MythicBukkit;
import io.lumine.mythic.bukkit.utils.Schedulers;
import io.lumine.mythic.bukkit.utils.config.properties.types.MenuProp;
import io.lumine.mythic.bukkit.utils.items.ItemFactory;
import io.lumine.mythic.bukkit.utils.logging.Log;
import io.lumine.mythic.bukkit.utils.menu.EditableMenuBuilder;
import io.lumine.mythic.bukkit.utils.menu.Icon;
import io.lumine.mythic.bukkit.utils.menu.MenuData;

public class SelectColorMenu extends CosmeticMenu<SelectColorContext> {

    public SelectColorMenu(MCCosmeticsPlugin core, MenuManager manager) {
        super(core, manager, new MenuProp(core, "menus/color_picker", "Menu", null));
    }

    @Override
    public EditableMenuBuilder<SelectColorContext> build(EditableMenuBuilder<SelectColorContext> builder) {

        builder.getIcon("BACK").ifPresent(icon -> {
            icon.getBuilder().click((context,player) -> {
                playMenuClick(player);
                context.goBack();
            });
        });

        builder.getIcon("COSMETIC").ifPresent(icon -> {
            icon.getBuilder()
                    .item((context,player) -> ItemFactory.of(context.getCosmetic().getMenuItem()).color(context.getChroma()))
                    .click((context,player) -> {
                        playMenuClick(player);
                        if(context.getManager().getWardrobeManager().isInWardrobe(player)) {
                            var mannequin = context.getManager().getWardrobeManager().getMannequin(player);

                            context.getManager().equipMannequin(mannequin, new EquippedCosmetic(context.getCosmetic(), context.getChroma()));
                            CommandHelper.sendSuccess(player, "Set wardrobe " + context.getCosmetic().getType() + " to " + context.getCosmetic().getDisplay());
                        } else {
                            if(MCCosmeticsPlugin.inst().getConfiguration().getEquipDelay() > 0) {
                                Schedulers.sync().runLater(() -> {
                                    context.getProfile().equip(context.getCosmetic(), context.getChroma());
                                }, MCCosmeticsPlugin.inst().getConfiguration().getEquipDelay());
                            } else {
                                context.getProfile().equip(context.getCosmetic(), context.getChroma());
                            }
                            CommandHelper.sendSuccess(player, "Set your " + context.getCosmetic().getType()+ " to " + context.getCosmetic().getDisplay());
                        }
                        player.closeInventory();
                    });
        });

        builder.getIcon("COLOR_PICKER").ifPresent(icon -> {
            icon.getBuilder().click((context,player) -> {
                playMenuClick(player);
                MythicBukkit.inst().getMenuManager().getColorPickerMenu().openMenu(player, context.getChroma()).thenAcceptSync(chroma -> {
                    context.setChroma(chroma);
                    context.openMenu();
                });
            });
        });

        buildAdvancedButtonOptions(builder);
        return builder;
    }

    public static class SuggestedColorSwatch implements MenuData<SelectColorContext> {

        
        
        @Override
        public Icon<SelectColorContext> getIcon() {
            // TODO Auto-generated method stub
            return null;
        }
        
    }
    
}
