package io.lumine.cosmetics.menus;

import io.lumine.cosmetics.MCCosmeticsPlugin;
import io.lumine.cosmetics.api.menus.SelectionMenuContext;
import io.lumine.cosmetics.types.MCCosmeticsManager;
import io.lumine.cosmetics.players.Profile;
import lombok.Data;
import org.bukkit.entity.Player;

@Data
public class SelectionMenuData implements SelectionMenuContext {

    private final MCCosmeticsManager manager;
    private final Profile profile;

    private String filter = "";
    private boolean showingUncollected = false;

    public boolean hasFilter() {
        return filter != null && !filter.isEmpty();
    }

    public void clearFilter() {
        this.filter = "";
    }

    public void openMenu(Player player) {
        MCCosmeticsPlugin.inst().getMenuManager().openCosmeticMenu(manager, profile,this);
    }

}
