package io.lumine.cosmetics.types.equipment;

import com.destroystokyo.paper.event.player.PlayerArmorChangeEvent;
import com.destroystokyo.paper.event.player.PlayerPostRespawnEvent;
import io.lumine.cosmetics.MCCosmeticsPlugin;
import io.lumine.cosmetics.players.Profile;
import io.lumine.mythic.bukkit.utils.Events;
import io.lumine.mythic.bukkit.utils.plugin.PluginModule;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryCloseEvent;

public class EquipmentManager extends PluginModule<MCCosmeticsPlugin> {

    public EquipmentManager(MCCosmeticsPlugin plugin) {
        super(plugin);
    }

    @Override
    public void load(MCCosmeticsPlugin plugin) {
        Events.subscribe(InventoryCloseEvent.class)
                .handler(event -> {
                    handleEquip((Player) event.getPlayer());
                }).bindWith(this);

        Events.subscribe(PlayerArmorChangeEvent.class)
                .handler(event -> {
                    handleEquip(event.getPlayer());
                }).bindWith(this);

        Events.subscribe(PlayerPostRespawnEvent.class)
                .handler(event -> {
                    handleEquip(event.getPlayer());
                }).bindWith(this);
    }

    @Override
    public void unload() {

    }

    private void handleEquip(Player player) {
        getPlugin().getProfiles().awaitProfile(player).thenAcceptAsync(maybeProfile -> {
            if(maybeProfile.isEmpty()) {
                return;
            }

            final Profile profile = maybeProfile.get();
            getPlugin().getVolatileCodeHandler().getCosmeticEquipmentHelper().sendEquippedCosmetics(profile);
        });
    }
}
