package io.lumine.cosmetics.types.equipment.hats;

import io.lumine.cosmetics.api.cosmetics.ColorableCosmetic;
import io.lumine.cosmetics.api.cosmetics.EquippedCosmetic;
import io.lumine.cosmetics.api.cosmetics.ItemCosmetic;
import io.lumine.cosmetics.api.menus.SelectionMenuContext;
import io.lumine.cosmetics.constants.CosmeticType;
import io.lumine.cosmetics.types.AbstractCosmetic;
import io.lumine.mythic.api.packs.Pack;
import io.lumine.mythic.bukkit.utils.items.ItemFactory;
import io.lumine.mythic.bukkit.utils.menu.Icon;

import org.bukkit.inventory.ItemStack;

import java.io.File;

public class Hat extends AbstractCosmetic implements ColorableCosmetic,ItemCosmetic {

	public Hat(HatManager manager, File file, String key) {
		this(manager, null, file, key);
	}

	public Hat(HatManager manager, Pack pack, File file, String key) {
	    super(manager, pack, file, CosmeticType.type(Hat.class), key);
	}

	@Override
	public ItemStack getCosmetic() {
		return getMenuItem();
	}

	@Override
	public ItemStack getCosmetic(EquippedCosmetic equipped) {
	    var item = getMenuItem();
	    
	    if(equipped.getVariant() != null) {
	        var variant = equipped.getVariant();
	        item = ItemFactory.of(item).color(variant.getColor()).build();
	    } else if(equipped.getColor() != null) {
	        item = ItemFactory.of(item).color(equipped.getColor()).build();
	    }

		return item;
	}
}
