package io.lumine.cosmetics.types.equipment.hats;

import com.destroystokyo.paper.event.player.PlayerArmorChangeEvent;
import com.destroystokyo.paper.event.player.PlayerPostRespawnEvent;
import io.lumine.cosmetics.MCCosmeticsPlugin;
import io.lumine.cosmetics.api.cosmetics.Cosmetic;
import io.lumine.cosmetics.api.cosmetics.EquippedCosmetic;
import io.lumine.cosmetics.api.cosmetics.manager.HideableCosmetic;
import io.lumine.cosmetics.api.players.CosmeticProfile;
import io.lumine.cosmetics.nms.cosmetic.VolatileEquipmentCosmeticHelper;
import io.lumine.cosmetics.types.MCCosmeticsManager;
import io.lumine.cosmetics.types.equipment.CosmeticEquipmentSlot;
import io.lumine.cosmetics.types.gestures.Gesture;
import io.lumine.cosmetics.nms.cosmetic.VolatileAppliedCosmeticHelper;
import io.lumine.cosmetics.players.Profile;
import io.lumine.mythic.api.packs.Pack;
import io.lumine.mythic.bukkit.utils.Events;
import io.lumine.mythic.bukkit.utils.events.extra.ArmorEquipEvent; 
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryCloseEvent;
import io.lumine.cosmetics.api.players.wardrobe.Mannequin;

import java.io.File;

public class HatManager extends MCCosmeticsManager<Hat> implements HideableCosmetic {
    
    public HatManager(MCCosmeticsPlugin plugin) {
        super(plugin, Hat.class);   
        
        load(plugin);
    }

    @Override
    public void load(MCCosmeticsPlugin plugin) {
        super.load(plugin);
    }

    @Override
    public Hat build(Pack pack, File file, String node) {
        return new Hat(this, pack, file, node);
    }

    @Override
    public void equip(CosmeticProfile profile) {
        getHelper().equip(profile, CosmeticEquipmentSlot.HAT);
    }

    @Override
    public void unequip(CosmeticProfile profile) {
        getHelper().unequip(profile, CosmeticEquipmentSlot.HAT);
    }
    
    @Override
    public void equipMannequin(Mannequin mannequin, EquippedCosmetic cosmetic) {
        getHelper().equipMannequin(mannequin, CosmeticEquipmentSlot.HAT, cosmetic);
    }
    
    @Override
    public void unequipMannequin(Mannequin mannequin) {
        getHelper().unequipMannequin(mannequin, CosmeticEquipmentSlot.HAT);
    }

    @Override
    public void show(CosmeticProfile profile) {
        profile.setHidden(getCosmeticClass(), false);
        getHelper().equip(profile, CosmeticEquipmentSlot.HAT);
    }

    @Override
    public void hide(CosmeticProfile profile, Cosmetic request) {
        if(!(request instanceof Gesture)) {
            return;
        }
        profile.setHidden(getCosmeticClass(), true);
        getHelper().unequip(profile, CosmeticEquipmentSlot.HAT);
    }

    protected VolatileEquipmentCosmeticHelper getHelper() {
        return getNMS().getCosmeticEquipmentHelper();
    }
}
