package io.lumine.cosmetics.types.sprays;

import java.io.File;

import io.lumine.mythic.bukkit.utils.Schedulers;
import io.lumine.mythic.bukkit.utils.logging.Log;
import io.lumine.mythic.bukkit.utils.maps.MapImage;
import lombok.Data;

@Data
public class SprayImage {

    public static final int MAP_SIZE = 128;
    
    private final SprayManager manager;
    
    private final File file;
    private final String name;
    private final int mapNumber;
    private byte[] pixels = null;
    
    public SprayImage(SprayManager sprayManager, File file, int mapNumber) {
        this.manager = sprayManager;
        this.file = file;
        this.name = file.getName().split("\\.")[0];
        this.mapNumber = mapNumber;
    }

    public byte[] getPixels() {
        if(pixels == null) {
            MapImage.imageToMapPixels(file, MAP_SIZE).ifPresent(pixels -> {
                this.pixels = pixels;
            });
        }
        return pixels;
    }

}
